#include "DriverJeuLaser.h"
#include "GestionSon.h"

int main(void)
{

// ===========================================================================
// ============= INIT PERIPH (faites qu'une seule fois)  =====================
// ===========================================================================

// Aprs excution : le coeur CPU est clock  72MHz ainsi que tous les timers
CLOCK_Configure();

// configuration du Timer 4 en dbordement 91s
Timer_1234_Init_ff(TIM4, 6552); //6552 quivalent  91s
	
// configuration du Timer 3 pour une PWM de frquence 100kHz
PWM_Init_ff(TIM3, 3, 720);
	
	
// Activation des interruptions issues du Timer 4
// Association de la fonction  excuter lors de l'interruption : timer_callback
// cette fonction (si crite en ASM) doit tre conforme  l'AAPCS
	
Active_IT_Debordement_Timer(TIM4, 2, callbackson);

// configuration de PortB.0 (PB0)
GPIO_Configure(GPIOB, 0, OUTPUT, ALT_PPULL);


//============================================================================	
	
StartSon();
while	(1)
	{
	}
}
