	PRESERVE8
	THUMB   
		

; ====================== zone de rservation de donnes,  ======================================
;Section RAM (read only) :
	area    mesdata,data,readonly ; Dclaration de la variable


;Section RAM (read write):
	area    maram,data,readwrite
		
VarTime	dcd 0 ; Rserve 32 bits en mmoire pour Vartime et on lui affecte la valeur 0

	EXPORT VarTime ;On rend la variable globale pour pouvoir l'observer avec le dbugger
	
; ===============================================================================================
	
;constantes (quivalent du #define en C)
TimeValue	equ 900000 ; TimeValue = 900000 


	EXPORT Delay_100ms ; la fonction Delay_100ms est rendue publique donc utilisable par d'autres modules.

		
;Section ROM code (read only) :		
	area    moncode,code,readonly
		


; REMARQUE IMPORTANTE 
; Cette manire de crer une temporisation n'est clairement pas la bonne manire de procder :
; - elle est peu prcise
; - la fonction prend tout le temps CPU pour... ne rien faire...
;
; Pour autant, la fonction montre :
; - les boucles en ASM
; - l'accs cr/lec de variable en RAM
; - le mcanisme d'appel / retour sous programme
;
; et donc possde un intrt pour dbuter en ASM pur

Delay_100ms proc ; dbut de procdure
	
	    ldr r0,=VarTime ; Stockage de l'adresse de VarTime dans r0	  
						  
		ldr r1,=TimeValue ; Stockage de l'adresse de TimeValue r1
		str r1,[r0] ; Ecriture de la valeur stocke dans r1 dans r0
		
BoucleTempo	 ; dbut de la boucle
		ldr r1,[r0] ; Stockage de la valeur pointe par r0 dans r1  				
						
		subs r1,#1 ; Dsincrmentation de la valeur de r1
		str  r1,[r0] ; Ecriture de la valeur de r1 dans r0
		bne	 BoucleTempo ; "Branch on Not Equal" --> Effectue un saut vers BoucleTempo si la valeur de r1 est diffrente de 0, sinon continue 
			
		bx lr ; renvoie la valeur de lr
		endp
		
		
	END	